import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;



/**
 * Piggy is stupid and fat. Farmer likes to eat piggy. FARMER (and Connor) LIKES BACON! Piggy = Bacon.
 * 
 * @author (B,C, E and G) 
 * @version (a version number or a date)
 */
public class Piggy  extends Animal
{


    private static final int EAST = 0;
    private static final int WEST = 1;
    private static final int NORTH = 2;
    private static final int SOUTH = 3;

    private int direction;
    
    /**
     * Act - do whatever the Piggy wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
         if (Greenfoot.isKeyDown("left")) {
             int x = getX();
             int y = getY();
             if (direction != WEST){
                 getImage().mirrorHorizontally();
                }
             direction = WEST;
             if (canMove()){
                 setLocation(x-1, y);
                                  
             }
         }
         if (Greenfoot.isKeyDown("right")) {
             int x = getX();
             int y = getY();
             direction = EAST;
             setImage("piggy.png");
             if (canMove()){
                 setLocation(x+1, y);
                
             }
         }
         if (Greenfoot.isKeyDown("down")) {
             int x = getX();
             int y = getY();
             direction = SOUTH;
             setImage("piggy.png");
             if (canMove()){
                 setLocation(x, y+1);
             }
         }
         if (Greenfoot.isKeyDown("up")) {
             int x = getX();
             int y = getY();
             direction = NORTH;
             setImage("piggy.png");
             if (canMove()){
                 setLocation(x, y-1);
             }
         }    
         if (canSee(Apple.class)) {
             eat(Apple.class);
             Greenfoot.playSound("slurp.wav");
             World myWorld= getWorld();

             
         }    
    }
    public boolean blockedDown()
    {
       List Rocks = getNeighbours(1, true, Rock.class); 
        return true;
    }
    
    public boolean blockedRight()
    {
        List Rocks = getNeighbours(1, true, Rock.class);
        return true;
    }
    
    public boolean blockedLeft()
    {
        List Rocks = getNeighbours(1, true, Rock.class);
        return true;
    }
    
    
    public boolean blockedUp()
    {
        List Rocks = getNeighbours(1, true, Rock.class);
        return true;
    }
    
    
    
    public boolean canMove()
    {
        World myWorld = getWorld();
        int x = getX();
        int y = getY();
        switch(direction) {
            case SOUTH :
                y++;
                break;
            case EAST :
                x++;
                break;
            case NORTH :
                y--;
                break;
            case WEST :
                x--;
                break;
        }
        //test for outside border
        if (x >= myWorld.getWidth() || y >= myWorld.getHeight()) {
            return false;
        }
        else if (x < 0 || y < 0) {
            return false;
        }
        List rocks = myWorld.getObjectsAt(x, y, Rock.class);
        if(rocks.isEmpty()) {
            return true;
        }
        else {
            return false;
        }
        
        
     }              
     
}